use metabase
go


/* table was info.dbo.data_dict                         */
drop table data_dict
go
create table data_dict (
  ddid  int     NOT NULL,
  dbase char(20)  NULL,
  owner char(20)  NULL,
  tbln  varchar(40)  NOT NULL,
  fldn  varchar(40)  NOT NULL,
  ddesc varchar(255)  NULL,
  xref  int     NULL,
  uid   int     NULL,
  stamp datetime        NULL
)
go

grant select on data_dict to public
go


sp_primarykey data_dict,  ddid
go

create trigger t_ddict_i on data_dict for insert
as
begin
declare @newnum int

select @newnum = 0

/* will get the next number and update the new record with new number */
        execute metabase..get_new_no 'data_dict',@newnum output
        update data_dict

     set data_dict.ddid = @newnum, uid = suser_id(),
                stamp = getdate()
          from data_dict, inserted
          where data_dict.ddid = inserted.ddid

        print '%1! IS THE NEW data_dict ID',@newnum
end

go


